#if !defined(AFX_CONFIGFILE_H__5FEF8EBF_8802_49D1_8C7F_83F1BD89351B__INCLUDED_)
#define AFX_CONFIGFILE_H__5FEF8EBF_8802_49D1_8C7F_83F1BD89351B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Protocol.h"
#include <Windows.h>
#include <stdio.h>

#define CONFIG_FILENAME 		"Shutdown.ini"

#define ShutdownParamSection	("[ShutdownParam]")
    #define S_SearchType            ("SearchType")  
	#define S_PortType				("PortType")
	#define S_PortNum				("PortNum")
	#define S_ACFailDelayTime		("ACFailDelayTime")
	#define S_ExtCmd				("ExternCommand")
	#define S_CommandDelayTime		("CommandDelayTime")
	#define S_ShutdownNeedTime		("ShutdownNeedTime")
	//#define S_SendMsg	       		("SendMessage")
#define EndSection				("[End]")
#define ENDOFLINE				0xffff

#define PORTSTR_DEFAULT PORTSTR_COM
//#define SEARCHTYPE_DEFAULT  

#define PORTSTR_USB		("USB")
#define PORTSTR_COM		("COM")






class CConfigFile
{
public:
	CConfigFile(void);
public:
	~CConfigFile(void);
public:
	int 	OpenFile(char *pszFileName, char *pszMode);
	int 	CloseFile();
	BOOL	GetFilePath(char * pszFilePath,const char *pszFileName);
	
	int 	FindSection(char *pszSection);
	int 	GetString(char *pszItem, char *pszItemVal);
	int 	GetInt(char *pszItem);
	int 	TrimString(char *pszDest, char *pszStr);
	int 	GetStringFromLine (char *pszDest, char *pszBuf, UINT *nStartPos, char szSeparator);
	int 	GetStringFromString (char *pszDest, char *pszSrc, UINT *nStartPos, char szSeparator);
	int 	GetItemFromLine(char * pszBuf, char *szItem, char *szItemValue);
	
	int 	GetShutdownParameter(PSHUTDOWNPARAM pShutdownParam);
	int 	SetShutdownParameter(PSHUTDOWNPARAM pShutdownParam);
	void 	SetDefaultShutdownParam(PSHUTDOWNPARAM pShutdownParam);
	
	int 	WriteOneLine (char *pszText, UINT uReturnNum);
	int 	WriteConfigurationFile();
	
private:
	FILE 			*m_pFilePointer;
	SHUTDOWNPARAM 	m_ShutdownParam;
};

#endif
