// ConfigShutdownParameterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ConfigShutdownParameter.h"
#include "ConfigShutdownParameterDlg.h"
#include "..\shutdownKernel\ListPorts.h"


#define EXTERNDELAY_TIME_COUNT  11


static	TCHAR	szPort[MAX_COMPORT_NUM][MAX_PORTNAME_LEN];
static	DWORD	dwComPortNum = 0;

char *g_szPortType[] = {PORTSTR_COM,PORTSTR_USB};


//
static BOOL CALLBACK GetComPort(LPVOID lpCallbackValue,LISTPORTS_PORTINFO* lpPortInfo)
{
	size_t length = wcslen((wchar_t *)(lpPortInfo->lpPortName));
	memcpy(szPort[dwComPortNum++], lpPortInfo->lpPortName, 2*length);
	return TRUE;
}



IMPLEMENT_DYNAMIC(CConfigShutdownParameterDlg, CDialog)

CConfigShutdownParameterDlg::CConfigShutdownParameterDlg(CWnd* pParent /*=NULL*/)
: CDialog(CConfigShutdownParameterDlg::IDD, pParent)
, m_szSearchType(_T(""))
, m_szCmd(_T(""))
, m_szPort(_T(""))
, m_CommandDelayTime(_T(""))
, m_szAcFaile(_T(""))
, m_szSDNeed(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	memset(&m_ShutdownParam,0,sizeof(m_ShutdownParam));
	m_pShutdownParam = NULL;
    m_szSearchType = _T("");
	m_CommandDelayTime = _T("60");
	m_szAcFaile = _T("60");
	m_szSDNeed = _T("180");
	m_hUpdateConfig = NULL;
	m_hUpdateConfigForComm = NULL;

	//imachine added 2010.07.12
	m_hUpdateStatusThread = NULL;
	m_hUpdateConnectionEvent = NULL;
}

CConfigShutdownParameterDlg::~CConfigShutdownParameterDlg()
{
	if (m_hUpdateConfig)
	{
		CloseHandle(m_hUpdateConfig);
	}
	if (m_hUpdateConfigForComm)
	{
		CloseHandle(m_hUpdateConfigForComm);
	}

	//imachine added 2010.07.12
	if (m_hUpdateConnectionEvent)
	{
		CloseHandle(m_hUpdateConnectionEvent);
	}
	if (m_hUpdateStatusThread)
	{
		CloseHandle(m_hUpdateStatusThread);
	}
}

BOOL CConfigShutdownParameterDlg::OnInitDialog()                   
{
	BOOL ret=CDialog::OnInitDialog();
	char	sztemp[20];
	int i;
	int index = 0;
	CListPorts	listport;
	CString			strtemp;
	memset(szPort, 0, sizeof(szPort));
	listport.ListPorts(GetComPort, NULL);
    
	SortComNo(szPort, dwComPortNum);//add by martin 2009-04-23

	HANDLE hToken;
	TOKEN_PRIVILEGES tkp;  // Get a token for this process.  

	SetTimer(1, 1000, NULL);

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	if (!OpenProcessToken(GetCurrentProcess(), 
		TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken)) 
		return ret;
	LookupPrivilegeValue(NULL, SE_DEBUG_NAME,
		&tkp.Privileges[0].Luid);  
	tkp.PrivilegeCount = 1;  // one privilege to set    
	tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;  

	AdjustTokenPrivileges(hToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0);
   
	
	strtemp.LoadString(SEARCHTYPE_AUTO);
	
	m_SearchType.InsertString(0,strtemp);
	strtemp.LoadString(SEARCHTYPE_MANUAL);
	m_SearchType.InsertString(1,strtemp);

	//mary add 2012.08.28
	strtemp.LoadString(SEARCHTYPE_SEMIAUTO);
	m_SearchType.InsertString(2,strtemp);
  	//mary add end
		
	for(index = 0,i=0; i<=600; i+=60)
	{
		sprintf_s(sztemp, "%d", i);
		m_pCommandTime.InsertString(index++,sztemp);
	}


	for(index = 0,i=0; i<60; i+=10)
	{
		sprintf_s(sztemp, "%d", i);
		m_CtlAcFail.InsertString(index++,sztemp);
	}

	for (i=60;i<=36000;i+=60)
	{
		sprintf_s(sztemp, "%d", i);
		m_CtlAcFail.InsertString(index++,sztemp);
	}

	for(index = 0,i=0; i<=600; i+=60)
	{
		sprintf_s(sztemp, "%d", i);
		m_CtlSDNeed.InsertString(index++,sztemp);
	}

	m_fileConfig.GetShutdownParameter(&m_ShutdownParam);
	m_szAcFaile.Format(_T("%d"), m_ShutdownParam.uACFailDelayTime);
	m_szSDNeed.Format(_T("%d"), m_ShutdownParam.uShutdownNeedTime);
	m_CommandDelayTime.Format(_T("%d"), m_ShutdownParam.uCommandDelayTime);
	m_SearchType.SetCurSel(m_ShutdownParam.uSearchType);

	
   	 if (m_ShutdownParam.uSearchType == SEARCHTYPE_DEFAULT)
	{
		m_CommuniPort.EnableWindow(FALSE);
		if (m_ShutdownParam.uPortType == COM)
		{
			sprintf_s(sztemp, "%s%d", PORTSTR_COM,m_ShutdownParam.uComPort);
		}
		else
		{
			sprintf_s(sztemp, "%s%d", PORTSTR_USB,m_ShutdownParam.uComPort);
		}
		m_CommuniPort.InsertString(0,sztemp);
		m_szCommuniPort.Format(_T("%s%d"),g_szPortType[m_ShutdownParam.uPortType],m_ShutdownParam.uComPort);
	}
	//mary add 2012.08.28
	else	 if (m_ShutdownParam.uSearchType == SEARCHTYPE_SEMI_AUTOMATIC)			
	{
		m_CommuniPort.EnableWindow(FALSE);
		sprintf_s(sztemp, "%s%d", PORTSTR_USB,m_ShutdownParam.uComPort);
		
		m_CommuniPort.InsertString(0,sztemp);
		m_szCommuniPort.Format(_T("%s%d"),g_szPortType[m_ShutdownParam.uPortType],m_ShutdownParam.uComPort);
	}
	//mary add end				
	else 
	{
		m_CommuniPort.EnableWindow(TRUE);
		for(index = 0,i=0;i<(int)dwComPortNum;i++)
		{
			sprintf_s(sztemp, "%s", szPort[i]);
			m_CommuniPort.InsertString(index++,sztemp);
		}
		m_szCommuniPort.Format(_T("%s%d"),g_szPortType[m_ShutdownParam.uPortType],m_ShutdownParam.uComPort);
	}
	

	m_szCmd = m_ShutdownParam.szExternCmd;

	//imachine added 2010.07.12
	m_hUpdateStatusThread = CreateThread(
		(LPSECURITY_ATTRIBUTES)NULL,
		0,
		(LPTHREAD_START_ROUTINE)UpdateConnectionStatus,
		(LPVOID)this,
		0,
		NULL);

	SetForegroundWindow();
	UpdateData(FALSE);

	return ret;
}

void CConfigShutdownParameterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);                
	DDX_Text(pDX, IDC_COMMAND, m_szCmd);
	DDV_MaxChars(pDX, m_szCmd, 255);
	DDX_Control(pDX, IDC_CMD_TIME, m_pCommandTime);
	DDX_CBString(pDX, IDC_CMD_TIME, m_CommandDelayTime);
	DDV_MaxChars(pDX, m_CommandDelayTime, 6);

	DDX_Control(pDX,IDC_CMD_SEARCH_TYPE,m_SearchType);
	DDX_CBString(pDX,IDC_CMD_SEARCH_TYPE,m_szSearchType);
	DDX_Control(pDX,IDC_CMD_COMMUNI_PORT,m_CommuniPort);
	DDX_CBString(pDX,IDC_CMD_COMMUNI_PORT,m_szCommuniPort);

	DDX_Control(pDX, IDC_CMD_ACFAIL_TIME, m_CtlAcFail);
	DDX_CBString(pDX, IDC_CMD_ACFAIL_TIME, m_szAcFaile);
	DDX_Control(pDX, IDC_CMD_SDNEED_TIME, m_CtlSDNeed);
	DDX_CBString(pDX, IDC_CMD_SDNEED_TIME, m_szSDNeed);
}

void CConfigShutdownParameterDlg::PostNCDestroy()
{
	delete this;
	CDialog::PostNcDestroy();
}

BEGIN_MESSAGE_MAP(CConfigShutdownParameterDlg, CDialog)
	ON_BN_CLICKED(IDOK, &CConfigShutdownParameterDlg::OnBnClickedOK)
	ON_BN_CLICKED(IDCANCEL, &CConfigShutdownParameterDlg::OnBnClickedBncancl)
	ON_STN_CLICKED(IDC_STATIC_COM_PORT, &CConfigShutdownParameterDlg::OnStnClickedStaticComPort)
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_CMD_SEARCH_TYPE, &CConfigShutdownParameterDlg::OnCbnSelchangeCmdSearchType)
	ON_REGISTERED_MESSAGE ( uMsgExit, OnMsgExit )	//imachine added 2010.07.15 close the window
END_MESSAGE_MAP()




void CConfigShutdownParameterDlg::OnBnClickedOK()
{
	// TODO: Add your control notification handler code here
	UpdateData(true);

	int iSignal = TestCommandExec();
	if ( !iSignal )
	{
		int Adlib;
		m_ShutdownParam.uCommandDelayTime = atoi(m_CommandDelayTime);
		m_ShutdownParam.uACFailDelayTime = atoi(m_szAcFaile);
		m_ShutdownParam.uShutdownNeedTime = atoi(m_szSDNeed);
		m_ShutdownParam.uSearchType = m_SearchType.GetCurSel();


		if(Adlib = m_szCommuniPort.Find(PORTSTR_COM,0) == -1)
		{
			m_ShutdownParam.uPortType = USB;
		}
		else
		{
			m_ShutdownParam.uPortType = COM;
		}

		//m_ShutdownParam.uComPort = m_CommuniPort.GetCurSel()+1; //modify by martin 2009-04-23

		if ( m_CommuniPort.IsWindowEnabled() )	//imachine added 2010.07.13
			m_ShutdownParam.uComPort = atoi((&szPort[m_CommuniPort.GetCurSel()][3]));

		strcpy_s(m_ShutdownParam.szExternCmd,MAX_EXTERNCMD_LEN,m_szCmd);

		m_fileConfig.SetShutdownParameter(&m_ShutdownParam);
		if (m_hUpdateConfig == NULL)
		{
			m_hUpdateConfig = OpenEvent(EVENT_ALL_ACCESS, FALSE, UPDATE_CONFIG_FILE);
		}

		SetEvent(m_hUpdateConfig);

		if (m_hUpdateConfigForComm == NULL)
		{
			m_hUpdateConfigForComm = OpenEvent(EVENT_ALL_ACCESS, FALSE, UPDATE_CONFIG_FILE_FOR_COMM);
		}

		SetEvent(m_hUpdateConfigForComm);
	}
	else
	{
		AfxMessageBox( "The command is executing, the configure is invalidate.", MB_ICONINFORMATION );
	}

	CDialog::OnOK();
}

void CConfigShutdownParameterDlg::OnBnClickedBncancl()
{
	CDialog::OnCancel();
}

void CConfigShutdownParameterDlg::OnPaint() 
{
	if(Create(IDD_CONFIG) == NULL) 
		return;

	int iWidthScreen,iHeightScreen;
	iWidthScreen=GetSystemMetrics(SM_CXFULLSCREEN);
	iHeightScreen=GetSystemMetrics(SM_CYFULLSCREEN);

	RECT rect;
	int iWidthDlg,iHeightDlg;
	GetWindowRect(&rect);
	iWidthDlg=rect.right-rect.left;     iHeightDlg=rect.bottom-rect.top;
	MoveWindow(iWidthScreen/2-iWidthDlg/2,iHeightScreen/2-iHeightDlg/2,iWidthDlg,iHeightDlg);

	ShowWindow(SW_SHOW);

	CDialog::OnPaint();
}

void CConfigShutdownParameterDlg::InitShutdownParam(PSHUTDOWNPARAM pShutdownParam)
{
	if(pShutdownParam)
	{
		memcpy(&m_ShutdownParam,pShutdownParam,sizeof(SHUTDOWNPARAM));
		m_pShutdownParam = pShutdownParam;
	}
}

BOOL CConfigShutdownParameterDlg::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CDialog::PreCreateWindow(cs) )
		return FALSE;

	cs.lpszClass = AfxRegisterWndClass(0);
	cs.lpszName	= "ConfigSDPara";
	return TRUE;
}


void CConfigShutdownParameterDlg::OnStnClickedStaticComPort()
{
	// TODO: Add your control notification handler code here
}
void CConfigShutdownParameterDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	SHUTDOWNPARAM ShutdownParam;
	if (nIDEvent == 1)
	{
		m_fileConfig.GetShutdownParameter(&ShutdownParam);
		m_szPort.Format(_T("%s%d"),g_szPortType[ShutdownParam.uPortType],ShutdownParam.uComPort);
	}
	//SetDlgItemText(IDC_CMD_COMMUNI_PORT, m_szPort);
	CDialog::OnTimer(nIDEvent);
}

void CConfigShutdownParameterDlg::OnCbnSelchangeCmdSearchType()
{
	// TODO: Add your control notification handler code here
	int index,i;
	char	sztemp[20];

	memset(sztemp, 0 , sizeof(sztemp));
	if (m_SearchType.GetCurSel() == 0)
	{
		m_CommuniPort.EnableWindow(FALSE);
		if (m_ShutdownParam.uPortType == COM)
		{
			sprintf_s(sztemp, "%s%d", PORTSTR_COM,m_ShutdownParam.uComPort);
		}
		else
		{
			sprintf_s(sztemp, "%s%d", PORTSTR_USB,m_ShutdownParam.uComPort);
		}
		m_CommuniPort.InsertString(0,sztemp);
		m_CommuniPort.SetCurSel(0);
	}
	//mary add 2012.08.28
	else	 if (m_SearchType.GetCurSel() == 2)			
	{
		m_CommuniPort.EnableWindow(FALSE);
		sprintf_s(sztemp, "%s%d", PORTSTR_USB,m_ShutdownParam.uComPort);
		
		m_CommuniPort.InsertString(0,sztemp);
		m_CommuniPort.SetCurSel(0);
	}
	//mary add end				
	else
	{
		m_CommuniPort.EnableWindow(TRUE);
		m_CommuniPort.ResetContent();
		for(index = 0,i=0;i<(int)dwComPortNum;i++)
		{
			sprintf_s(sztemp, "%s", szPort[i]);
			m_CommuniPort.InsertString(index++,sztemp);
		}
		m_CommuniPort.SetCurSel(0);
	}
}
void CConfigShutdownParameterDlg::SortComNo(TCHAR szComNo[][MAX_PORTNAME_LEN], int uComNum)
{
	int arrComNo[MAX_COMPORT_NUM];
	int index = 0;
	int subIndex = 0;

	memset(arrComNo, 0, sizeof(arrComNo));
	for (index = 0; index < uComNum; index++ )
	{
		arrComNo[index] = atoi(&szComNo[index][3]);
	}
	for (index = 0; index < uComNum; index++)
	{
		int uMinCom, uMinIndex;
		TCHAR szMinCom[MAX_PORTNAME_LEN];

		memset(szMinCom, 0, MAX_PORTNAME_LEN);
		strcpy_s(szMinCom, MAX_PORTNAME_LEN, szComNo[index]);
		uMinCom = arrComNo[index];
		uMinIndex = index;

		for( subIndex = index + 1; subIndex < uComNum; subIndex++)
		{
			if (uMinCom > arrComNo[subIndex])
			{
				uMinIndex = subIndex;
				uMinCom = arrComNo[subIndex];
				strcpy_s(szMinCom, MAX_PORTNAME_LEN, szComNo[subIndex]);
			}
		}
		if(uMinIndex != index)
		{
			arrComNo[uMinIndex] = arrComNo[index];
			arrComNo[index] = uMinCom;

			strcpy_s(szComNo[uMinIndex] ,MAX_PORTNAME_LEN, szComNo[index]);
			strcpy_s(szComNo[index], MAX_PORTNAME_LEN, szMinCom);
		}
	}

}


//
// Update Communication port status
// Date: 2010.07.12
//
DWORD WINAPI UpdateConnectionStatus( LPVOID lpParam )
{
	char	sztemp[20];
	int		i;
	int		index = 0;
	SHUTDOWNPARAM	Shutdownparam;
	memset(&Shutdownparam, 0, sizeof(Shutdownparam));

	CConfigShutdownParameterDlg *pConfigSD = (CConfigShutdownParameterDlg*) lpParam;

	pConfigSD->m_hUpdateConnectionEvent = OpenEvent(EVENT_ALL_ACCESS, FALSE, UPDATE_CONNECTION_STATUS );
	
	while( 1 )
	{
		if ( WaitForSingleObject(pConfigSD->m_hUpdateConnectionEvent, 100) == WAIT_OBJECT_0 )
		{
			pConfigSD->m_fileConfig.GetShutdownParameter(&Shutdownparam);
			if (Shutdownparam.uSearchType == SEARCHTYPE_DEFAULT)
			{
				pConfigSD->m_CommuniPort.EnableWindow(FALSE);
				if (Shutdownparam.uPortType == COM)
				{
					sprintf_s(sztemp, "%s%d", PORTSTR_COM,Shutdownparam.uComPort);
				}
				else
				{
					sprintf_s(sztemp, "%s%d", PORTSTR_USB,Shutdownparam.uComPort);
				}
				pConfigSD->m_CommuniPort.InsertString(0,sztemp);
				pConfigSD->m_szCommuniPort.Format(_T("%s%d"),g_szPortType[Shutdownparam.uPortType],Shutdownparam.uComPort);

			}
			//mary add 2012.08.28
			else	 if (Shutdownparam.uSearchType == SEARCHTYPE_SEMI_AUTOMATIC)			
			{
				pConfigSD->m_CommuniPort.EnableWindow(FALSE);
				sprintf_s(sztemp, "%s%d", PORTSTR_USB,Shutdownparam.uComPort);
				
				pConfigSD->m_CommuniPort.InsertString(0,sztemp);
				pConfigSD->m_szCommuniPort.Format(_T("%s%d"),g_szPortType[Shutdownparam.uPortType],Shutdownparam.uComPort);
			}
			//mary add end	
			else
			{
				pConfigSD->m_CommuniPort.EnableWindow(TRUE);
				for(index = 0,i=0;i<(int)dwComPortNum;i++)
				{
					sprintf_s(sztemp, "%s", szPort[i]);
					pConfigSD->m_CommuniPort.InsertString(index++,sztemp);
				}
				pConfigSD->m_szCommuniPort.Format(_T("%s%d"),g_szPortType[Shutdownparam.uPortType],Shutdownparam.uComPort);
			}

			ResetEvent( pConfigSD->m_hUpdateConnectionEvent );
			pConfigSD->UpdateData(FALSE);
		}
	}

	return 0;
}


//
//imachine added 2010.07.15 close the window
//
LRESULT CConfigShutdownParameterDlg::OnMsgExit ( WPARAM   wParam,   LPARAM   lParam )
{
	PostMessage( WM_QUIT, 0, 0 );
	return 0;
}


int CConfigShutdownParameterDlg::TestCommandExec()
{
	HANDLE		hUpdateOmronCtrl = NULL;
	hUpdateOmronCtrl = OpenEvent(EVENT_ALL_ACCESS, FALSE, UPDATE_OMRON_OPTION );
	if ( hUpdateOmronCtrl != NULL )
	{
		if ( WaitForSingleObject( hUpdateOmronCtrl, 0 ) == WAIT_OBJECT_0 )
		{
			return 1;
		}
	}

	return 0;
}
