// file Protocol.h
#ifndef _INC_PROTOCOL
#define _INC_PROTOCOL

#include <Windows.h>

#define UPSNOTFND	0x11 // UPS Comunication Lost.

#define SZ_NAMED_PIPE      "\\\\.\\pipe\\__SDPIPE"

#define UPS_STATUS_BATTLOW			0x1
#define UPS_STATUS_ACFAIL			0x2
#define UPS_STATUS_SHUTDOWN			0x4
#define UPS_STATUS_SD_OS_UPS				0x8
#define UPS_STATUS_SD_OS_RESTART_LATER		0x10
#define UPS_STATUS_ONLY_SD_OS				0x20

#define SZSERVICENAME		"Simple Shutdown Service"
#define SZDISPLAYNAME		SZSERVICENAME

#define EVENTLOG_FILE_NAME	"EventLog.txt" 
#define MAX_EVENTLOG_COUNT	2000
#define MAX_LINELENGTH			512

#define UPSSTATUSSHMNAME	"Global\\SHARINGUPSSTATUS"// the name of sharing memory for UPS data
#define UPSSTATUSSYNCFILEMAPPING		"Global\\UpsStatusSyncFileMap"

#define CONFIGSDPARA_FILENAME "ConfigShutdownParameter.exe"

// iShutdownStatus
#define SHUTDOWNSTATUS_NONE		0x0
#define	SHUTDOWNSTATUS_STOP		0x1// When AC fail delay time elapsed, the value is set.

// iACFailStatus
#define ACFAILSTATUS_NONE		0x00 // No AC fail
#define	ACFAILSTATUS_ACFAIL		0x01 // AC fail
#define UPSSTATUS_BATTLOW		0x02 //	UPS battery low
#define UPSSTAUTS_COMEST		0x03 //	Communication normal
#define UPSSTATUS_COMLST		0x04 // Communication lost
#define UPSSTATUS_SD_OS_UPS_BY_OMRON				0x7
#define UPSSTATUS_SD_OS_RESTART_LATER_BY_OMRON		0x8
#define UPSSTATUS_ONLY_SD_OS_BY_OMRON				0x9

#define UPSNORMAL	0x20 // UPS is online
#define BATNORMAL	0x21 // UPS battery is Normal
#define UPSCOMEST	0x22 // UPS Comm Establish
#define UPSACFAIL	0x23 // UPS AC Fail
#define UPSBATLOW	0x24// UPS Battery Low, which is for Battery Status.
#define UPSNOAGENT	0x25 // Agent is stopped
#define SD_OS_UPS_BY_OMRON	0x26 // shutdown os and ups
#define ONLY_SD_OS_BY_OMRON	0x27 // only shutdown OS
#define RESTART_OS_LATER_BY_OMRON	0x28 // Restart OS later

#define UPDATE_CONFIG_FILE "Global\\Update Config File"
#define UPDATE_CONFIG_FILE_FOR_COMM "Global\\Update Config File For Comm"
#define UPDATE_CONNECTION_STATUS	"Global\\Update Connection status"
#define UPS_CMD_SN					"Global\\UPS CMD SN"

#define UPDATE_OMRON_OPTION			"Global\\Set Omronctl Option"

#define READPIP_EVENT_NAME "Read Pip"

#define		DEV_NAME_LEN		256

//this len is that agent allocs the space for data.
#define		DATA_BUF_LEN		50

//report len
#define		INPUT_REPORT_LEN	65
#define		OUTPUT_REPORT_LEN	17

enum PortType { COM = 0,USB };
enum SearchType {AutoSearch = 0,UserDefined};
#define PORTTYPE_DEFAULT			0

#define SEARCHTYPE_DEFAULT			0 //0:Auto,1:manual
#define SEARCHTYPE_SEMI_AUTOMATIC 		2//mary add 2012.08.28

#define COMPORT_DEFAULT				1
#define ACFAILDELAY_DEFAULT			60
#define SDNEEDTIME_DEFAULT			180
#define EXTERNCMD_DELAY_DEFAULT		0
#define EXTERNCMD_DEFAULT			_T("")
#define SENDMSG_DEFAULT				FALSE

#define MAX_EXTERNCMD_LEN		256
#define SHM_DATA_AVAILABLE		1

typedef struct _SHUTDOWNPARAM
{
	UINT    uSearchType;
	UINT	uCommuniPort;
	UINT	uPortType;
	UINT 	uComPort;
	UINT 	uACFailDelayTime;
	UINT	uCommandDelayTime;
	UINT 	uShutdownNeedTime;
	char	szExternCmd[MAX_EXTERNCMD_LEN];
	char	szExternSearchType[MAX_EXTERNCMD_LEN];
} SHUTDOWNPARAM, *PSHUTDOWNPARAM;

typedef struct _SHUTDOWN_AGENT 
{
	int	iShutdownStatus;
	DWORD iACFailStatus;
	int iReserved;
} SHUTDOWN_AGENT , *PSHUTDOWN_AGENT;

typedef DWORD UPSSTATUS;

typedef struct tagUPSINFORMATION {
	DWORD		dwComID;			/* The real com port id */
	PortType	ptPortType;			/* The port type USB or COM */
	DWORD		dwConfigInfo;		/* The com port config info */
	UPSSTATUS	dwUPSStatus;		/* Indicates current UPS status with bit, 
									it is composed of the response of Q1, V, V2, V3 */
	DWORD		dwReserved;		//river added for reserved
} UPSINFORMATION, *PUPSINFORMATION;

typedef struct tagPIPE_DATA
{
	char szCmd [12];
	int  nValue;
} PIPE_DATA, * PPIPE_DATA;

typedef struct tagUSBDNAME{
	int		index;
	char	DeviceNamestr[DEV_NAME_LEN];
}USBDNAME, *PUSBDNAME;

typedef struct _SHM_DATA
{
	BOOL uDataAvailable;
	UINT uPortType ;
	UINT uPortNum;
	UINT uConnStatus;
	DWORD dwUPSStatus;
}SHM_DATA;




typedef struct _SHM_DATA_OMRON{
	UINT uCmd;
	UINT uPara1;
	UINT uPara2;
	UINT uPara3;
	UINT uPara4;
}SHM_DATA_OMRON;

#define UPS_CMD_SNRM		77
#define UPS_CMD_SNRM_MAX_M	99999
#define UPS_CMD_SNRM_MIN_M	1


#endif
