#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <crtdbg.h>
#include <tchar.h>
#include "XUnzip.h"
#include "XZip.h"


#pragma   comment(lib,"shell32.lib")
#pragma   comment(lib,"Advapi32.lib")

#include "con_res.h"
#include "con_draw.h"

#define CHAR_YES_CAP "Y"
#define CHAR_YES_MIN "y"

#define CHAR_NO_CAP "N"
#define CHAR_NO_MIN "n"




#define SERVICE_FILE_NAME	"shutdownKernel.exe"
#define AGENT_MANAGER_BIN	"ShutdownManager.exe"
#define SIMPLE_SD_DATA		"SimpleSD2.2Data.zip"

#define COMPARE_BUF_SIZE (64*1024)
#define IsValidFileHandle(x)	((x) && ((x) != INVALID_HANDLE_VALUE))

BOOL Zip(LPCTSTR lpszZipArchive);
BOOL UnZip(LPCTSTR lpszZipArchive);
void VerifyZip(HZIP hz, LPCTSTR lpszFile);
BOOL Compare(LPCTSTR lpszFile1, LPCTSTR lpszFile2, BOOL *pbResult);

BOOL GetSimpleSDWarePath(char *pszPath);
int GetReturnDataFromPipe(LPCTSTR lpApplicationName,const char* lpCommandLine, char *szReturnBuff, int nSign);

int main(int argc, char ** argv)
{
	char szInstallPath[MAX_PATH];
	char cCar = 0;
	char szInput[MAX_PATH];
	char szBinFile[MAX_PATH];
	char szReturnBuff[1024];

	if (argc == 2 && strcmp(argv[1], "zip2.2") == 0)
	{
		BOOL bRet = Zip(SIMPLE_SD_DATA);
		return bRet;
	}

	DrawTitleWithDeck(g_strCon_Str[0], TRUE);

	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),FOREGROUND_RED);
	DrawCommonItem(1, g_strCon_Str[1], TRUE);
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),0x0007);
	

	con_Tmp_Init();
	con_Tmp_Print();
	con_Tmp_Close();

	while (1)
	{
		DrawCommonItem(1, g_strCon_Str[2], FALSE);

		memset(szInput, 0x00, sizeof(szInput));
		con_MyGets(szInput);

		if (strcmp(CHAR_NO_CAP, szInput) == 0 || strcmp(CHAR_NO_MIN, szInput) == 0)
		{
			return 0;
		}
		else if (strcmp(CHAR_YES_CAP, szInput) == 0 || strcmp(CHAR_YES_MIN, szInput) == 0)
		{

			memset(szInstallPath, 0x00, sizeof(szInstallPath));
			if (!GetSimpleSDWarePath(szInstallPath))
			{
				DrawCommonItem(1, g_strCon_Str[8], TRUE);
				conGetAnyKeyActive();
				return 0;
			}
			else
			{
				SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),FOREGROUND_RED);
				memset(szBinFile, 0x00, sizeof(szBinFile));
				sprintf(szBinFile, "%s"AGENT_MANAGER_BIN, szInstallPath);
				GetReturnDataFromPipe(szBinFile, "stop", szReturnBuff, FALSE);
				DrawCommonItem(1, g_strCon_Str[4], TRUE);

				memset(szBinFile, 0x00, sizeof(szBinFile));
				sprintf(szBinFile, "%s"SERVICE_FILE_NAME, szInstallPath);
				GetReturnDataFromPipe(szBinFile, "remove", szReturnBuff, FALSE);
				DrawCommonItem(1, g_strCon_Str[3], TRUE);
				
			
				DrawCommonItem(1, g_strCon_Str[5], TRUE);
				UnZip(SIMPLE_SD_DATA);

				memset(szBinFile, 0x00, sizeof(szBinFile));
				sprintf(szBinFile, "%s"SERVICE_FILE_NAME, szInstallPath);
				GetReturnDataFromPipe(szBinFile, "install", szReturnBuff, FALSE);
				DrawCommonItem(1, g_strCon_Str[6], TRUE);

				memset(szBinFile, 0x00, sizeof(szBinFile));
				sprintf(szBinFile, "%s"AGENT_MANAGER_BIN, szInstallPath);
				ShellExecute(NULL, "open", szBinFile, "", NULL, SW_SHOWNORMAL);
				DrawCommonItem(1, g_strCon_Str[7], TRUE);

				SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),0x0007);

				DrawCommonItem(0, NULL, TRUE);
				DrawCommonItem(1, g_strCon_Str[9], TRUE);
				conGetAnyKeyActive();
			}			
			return 0;
		}
		else
		{
			DrawCommonItem(1, g_szInputError, TRUE);
			conGetAnyKeyActive();
		}
	}

	return 0;
}

BOOL GetSimpleSDWarePath(char *pszPath)
{
	long	lret = 0;
	HKEY	hKey;
	HKEY	hSubKey;
	char	szKeyPath[512] = {0};
	char	tszKeyPath[] = "SOFTWARE\\Omron\\Simple Shutdown";
	char	tszKeyPath_64[] = "SOFTWARE\\Wow6432Node\\Omron\\Simple Shutdown";
		
	char 	tszPath[512] = {0};
	BYTE	tszSubPath[64] = {0};
	BYTE	tszData[512] = {0};
	DWORD	dwType, dwCbData = 512;

	hKey = HKEY_LOCAL_MACHINE;

	lret = RegOpenKeyEx(hKey,				// the key
						tszKeyPath,			// the subkey name
						0,					// reserve
						KEY_ALL_ACCESS,		// desired access
						&hSubKey );			// store the hkey of the subkey
	
	strcpy(szKeyPath, tszKeyPath);
	if ( lret != ERROR_SUCCESS ) //open fails
	{
		lret = RegOpenKeyEx(hKey,				// the key
							tszKeyPath_64,		// the subkey name
							0,					// reserve
							KEY_ALL_ACCESS,		// desired access
							&hSubKey );			// store the hkey of the subkey
		if(lret != ERROR_SUCCESS)
		{
			return FALSE;
		}
		memset(szKeyPath, 0, sizeof(szKeyPath));
		strcpy(szKeyPath, tszKeyPath_64);
	}
	
	ZeroMemory(tszSubPath, sizeof(tszSubPath));
	lret = RegEnumKey(hSubKey, 0, (char *)tszSubPath, sizeof(tszSubPath));
	
	if ( lret != ERROR_SUCCESS ) //open fails
	{
		return FALSE;
	}
	strcpy((char *)tszSubPath,"Folder");
	strcpy((char *)tszPath, (char *)szKeyPath);
	strcat((char *)tszPath, "\\");
	strcat((char *)tszPath, (char *)tszSubPath);
	RegCloseKey(hSubKey);
	
	lret = RegOpenKeyEx(hKey,				// the key
						tszPath,			// the subkey name
						0,					// reserve
						KEY_ALL_ACCESS,		// desired access
						&hSubKey );			// store the hkey of the subkey
	
	if ( lret != ERROR_SUCCESS ) //open fails
	{
		return FALSE;
	}
	
	lret = RegQueryValueEx(hSubKey,			// the subkey of runservices
						   "Path",	// the value name
						   NULL,			// reserve value
						   &dwType,			// type
						   tszData,			// the path of the routine file
						   &dwCbData);		// the length of tszPath
	
	RegCloseKey(hSubKey);
	
	if ( lret != ERROR_SUCCESS ) //open fails
	{
		return FALSE;
	}

	strcpy(pszPath, (const char *)tszData);
	if(tszData[strlen((const char *)tszData)-1] != '\\')
	{
		strcat(pszPath, "\\");
	}

	return TRUE;
}

int GetReturnDataFromPipe(LPCTSTR lpApplicationName,const char* lpCommandLine, char *szReturnBuff, int nSign)
{
	SECURITY_ATTRIBUTES		sa;
	HANDLE					hRead,hWrite;
	STARTUPINFO				si;
	PROCESS_INFORMATION		pi;
	DWORD					bytesRead;
	char					szCommand[MAX_PATH];
	char					buffer[4096];
	
	
	
	memset(szCommand, 0, MAX_PATH);
	if (nSign == TRUE)
		sprintf(szCommand, "cmd.exe /C \"cscript \"%s\" %s\"", lpApplicationName, lpCommandLine);
	else
		sprintf(szCommand, "cmd.exe /C \"\"%s\" %s\"", lpApplicationName, lpCommandLine);
	
	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.lpSecurityDescriptor = NULL;
	sa.bInheritHandle = TRUE;
	
	if (!CreatePipe(&hRead,&hWrite,&sa,0))
	{
		return NULL;
	}
	
	si.cb = sizeof(STARTUPINFO);
	GetStartupInfo(&si);
	si.hStdError = hWrite;
	si.hStdOutput = hWrite;
	si.wShowWindow = SW_HIDE;
	si.dwFlags = STARTF_USESHOWWINDOW | STARTF_USESTDHANDLES;

	if (!CreateProcess(NULL,szCommand,
						NULL,NULL,TRUE,NULL,NULL,NULL,&si,&pi))
	{
		return NULL;
	}
	if(WaitForSingleObject(pi.hProcess, INFINITE)==WAIT_FAILED)
	{
		return NULL;
	}
	CloseHandle(hWrite);
	
	
	
	
	memset(buffer, 0, 4096);
	while(1)
	{
		if(ReadFile(hRead,buffer,4096,&bytesRead,NULL) != NULL)
		{
			strcat(szReturnBuff, buffer);
		}
		else
			break;
	}
	
	return 0;
}


BOOL Zip(LPCTSTR lpszZipArchive)
{
	BOOL bResult = TRUE;

	_ASSERTE(lpszZipArchive);
	_ASSERTE(lpszZipArchive[0] != _T('\0'));

	if (!lpszZipArchive || lpszZipArchive[0] == _T('\0'))
		return FALSE;


	HZIP hz = CreateZip((void *)lpszZipArchive, 0, ZIP_FILENAME);
	if (hz)
	{
		ZRESULT zr = ZipAdd(hz, "ConfigShutdownParameter.exe", (void *)"ConfigShutdownParameter.exe", 0, ZIP_FILENAME);
		zr = ZipAdd(hz, "USBDLL.dll", (void *)"USBDLL.dll", 0, ZIP_FILENAME);
		zr = ZipAdd(hz, "Message.dll", (void *)"Message.dll", 0, ZIP_FILENAME);
		zr = ZipAdd(hz, "shutdownKernel.exe", (void *)"shutdownKernel.exe", 0, ZIP_FILENAME);
		zr = ZipAdd(hz, "ShutdownManager.exe", (void *)"ShutdownManager.exe", 0, ZIP_FILENAME);

		CloseZip(hz);
		// did add work?
		if (zr == ZR_OK)
		{
			bResult = TRUE;
		}
		else
		{
			bResult = FALSE;
		}
	}
	else
	{
		bResult = FALSE;
	}

	return bResult;
}


BOOL UnZip(const char* lpszZipArchive)
{
	int numitems = 0;
#ifdef _UNICODE
	ZIPENTRYW ze;
#else
	ZIPENTRY ze; 
#endif
	HZIP hz = OpenZip((void *)lpszZipArchive, 0, ZIP_FILENAME);

	if (hz)
	{
		GetZipItem(hz, -1, &ze); 
		numitems = ze.index;

		for (int i = 0; i < numitems; i++)
		{ 
			GetZipItem(hz, i, &ze);
			VerifyZip(hz, ze.name);
		}

		CloseZip(hz);
		return TRUE;
	}
	return FALSE;
}

void VerifyZip(HZIP hz, LPCTSTR lpszFile)
{
#ifdef _UNICODE
	ZIPENTRYW ze;
#else
	ZIPENTRY ze; 
#endif
	FILE *fp = NULL;

	memset(&ze, 0, sizeof(ze));
	int index = -1;
	ZRESULT zr = 0;
	TCHAR targetname[MAX_PATH];

	zr = FindZipItem(hz, lpszFile, TRUE, &index, &ze);

	if (zr == ZR_OK)
	{
	}
	else
	{
		return ;
	}

	if (_tcscmp(lpszFile, ze.name) == 0)
	{
	}
	else
	{
		return ;
	}

	memset(targetname, 0x00, sizeof(targetname));
	GetSimpleSDWarePath(targetname);
	strcat(targetname, lpszFile);

	// delete target file if it exists
	::DeleteFile(targetname);

	zr = UnzipItem(hz, index, targetname, 0, ZIP_FILENAME);

	if (zr == ZR_OK)
	{
	}
	else
	{
		return ;
	}

	fp = fopen(targetname, "r");
	
	if (NULL != fp)
	{
		fclose(fp);
	}
	else
	{
		return ;
	}
}


BOOL Compare(LPCTSTR lpszFile1, LPCTSTR lpszFile2, BOOL *pbResult)
{
	_ASSERTE(pbResult);
	if (!pbResult)
		return FALSE;

	*pbResult = FALSE;

	BOOL bCompare = FALSE;		// TRUE = files identical
								// FALSE = files not identical
	BOOL bOp = TRUE;			// TRUE = no API failures, compare completed
								// FALSE = file or memory API failed

	_ASSERTE(lpszFile1);
	_ASSERTE(lpszFile1[0] != _T('\0'));

	if (!lpszFile1 || lpszFile1[0] == _T('\0'))
		return FALSE;

	_ASSERTE(lpszFile2);
	_ASSERTE(lpszFile2[0] != _T('\0'));

	if (!lpszFile2 || lpszFile2[0] == _T('\0'))
		return FALSE;

	HANDLE hFile1 = NULL, hFile2 = NULL;

	printf(_T("opening '%s'"), lpszFile1);

	// open file 1
	hFile1 = ::CreateFile(lpszFile1,
						  GENERIC_READ,
						  FILE_SHARE_READ | FILE_SHARE_WRITE,
						  NULL,
						  OPEN_EXISTING,
						  FILE_ATTRIBUTE_NORMAL,
						  NULL);

	if (hFile1 == INVALID_HANDLE_VALUE)
	{
		printf(_T("ERROR: %s failed\n"), _T("CreateFile"));
		return FALSE;
	}

	printf(_T("opening '%s'"), lpszFile2);

	// open file 2
	hFile2 = ::CreateFile(lpszFile2,
						  GENERIC_READ,
						  FILE_SHARE_READ | FILE_SHARE_WRITE,
						  NULL,
						  OPEN_EXISTING,
						  FILE_ATTRIBUTE_NORMAL,
						  NULL);

	if (hFile2 == INVALID_HANDLE_VALUE)
	{
		printf(_T("ERROR: %s failed\n"), _T("CreateFile"));
		::CloseHandle(hFile1);
		return FALSE;
	}

	DWORD dwFileSize1 = ::GetFileSize(hFile1, NULL);
	DWORD dwFileSize2 = ::GetFileSize(hFile2, NULL);

	if ((dwFileSize1 != INVALID_FILE_SIZE) && (dwFileSize2 != INVALID_FILE_SIZE))
	{
		// continue if file sizes match
		if (dwFileSize1 == dwFileSize2)
		{
			BYTE * pBuf1 = new BYTE [COMPARE_BUF_SIZE];
			_ASSERTE(pBuf1);

			BYTE * pBuf2 = new BYTE [COMPARE_BUF_SIZE];
			_ASSERTE(pBuf2);

			if (pBuf1 && pBuf2)
			{
				while (dwFileSize1)
				{
					DWORD dwBytesRead1 = 0;
					BOOL bRet1 = ::ReadFile(hFile1, 
											(LPVOID) pBuf1, 
											COMPARE_BUF_SIZE, 
											&dwBytesRead1, 
											NULL);

					if (!bRet1)
					{
						printf(_T("ERROR: %s failed\n"), _T("ReadFile"));
						bOp = FALSE;
						break;
					}

					DWORD dwBytesRead2 = 0;
					BOOL bRet2 = ::ReadFile(hFile2, 
											(LPVOID) pBuf2, 
											COMPARE_BUF_SIZE, 
											&dwBytesRead2, 
											NULL);

					if (!bRet2)
					{
						printf(_T("ERROR: %s failed\n"), _T("ReadFile"));
						bOp = FALSE;
						break;
					}

					if (dwBytesRead1 != dwBytesRead2)
					{
						printf(_T("Compare failed ==> file Read sizes different\n"));
						break;
					}

					if (dwBytesRead1 == 0)
					{
						// Read ok, but nothing read
						printf(_T("Read %s ==> EOF reached.\n"), lpszFile1);
						bCompare = TRUE;
						break;
					}

					if (dwBytesRead2 == 0)
					{
						// Read ok, but nothing read
						printf(_T("Read %s ==> EOF reached.\n"), lpszFile2);
						bCompare = TRUE;
						break;
					}

					// do contents match?
					int nCmp = memcmp(pBuf1, pBuf2, dwBytesRead1);
					if (nCmp != 0)
					{
						printf(_T("Compare failed ==> file contents different\n"));
						break;
					}

					dwFileSize1 -= dwBytesRead1;

				} // while (dwFileSize1)

				if (dwFileSize1 == 0)					
					bCompare = TRUE;

				if (pBuf1)
					delete [] pBuf1;
				if (pBuf2)
					delete [] pBuf2;
			}
			else
			{
				// memory allocation failed
				printf(_T("ERROR: memory allocation failure\n"));
				bOp = FALSE;
			}
		}
		else
		{
			printf(_T("Compare failed ==> file sizes different\n"));
		}
	}
	else
	{
		// GetFileSize failed
		printf(_T("ERROR: %s failed\n"), _T("GetFileSize"));
		bOp = FALSE;
	}

	if (IsValidFileHandle(hFile1))
		::CloseHandle(hFile1);
	if (IsValidFileHandle(hFile2))
		::CloseHandle(hFile2);

	*pbResult = bCompare;

	return bOp;
}