// EventRes_En.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "EventRes.h"

EVENT_PARAM_STR Event_Param_Str[] = 
{
	{ID_AGENT_STOP,								UPS_EVENT_SERVICE_STOP,					"Shutdown Agent Stop."},
	{ID_AGENT_START,							UPS_EVENT_SERVICE_START,				"Shutdown Agent Start."},
	{ID_UPS_ACFAIL,								UPS_EVENT_ACFAIL,						"AC line failure."},
	{ID_UPS_BATTERY_LOW,						UPS_EVENT_BATTERY_LOW,					"Battery Low."},
	{ID_UPS_COMM_EST,							UPS_EVENT_COMM_EST,						"Communication Establish."},
	{ID_UPS_COMM_LOST,							UPS_EVENT_COMM_LOST,					"Communication Lost."},
	{ID_UPS_ACFAIL_RECOVER,						UPS_EVENT_ACFAIL_RECOVER,				"AC line failure recover."},
	{ID_SHUTDOWN,								UPS_EVENT_SHUTDOWN,						"Shutdown."},
	{ID_RUN_EXTERNCMD,							UPS_EVENT_EXCMD,						"Run External Command."},
	/////////////////////////
	{ID_SD_OS_UPS_BY_OMRON,						UPS_EVENT_SD_OS_AND_UPS_BY_OMRON,		"Shutdown OS and UPS by omronctl process."},
	{ID_SD_OS_RESTART_LATER_BY_OMRON,			UPS_EVENT_SD_OS_RESTART_LATER_BY_OMRON,	"Shutdown OS and UPS. After %1 Min, the UPS will be Power On"},
	{ID_ONLY_SD_OS_BY_OMRON,					UPS_EVENT_ONLY_SD_OS_BY_OMRON,			"Shutdown and restart OS by omronctl process."},
	//////////////////////////////////////////
#if 0
	{ID_OC_ERROR_RUNNING,						UPS_EVENT_OC_ERROR_RUNNING,				"omronctl already running."},
	{ID_OC_ERROR_PARAM,							UPS_EVENT_OC_ERROR_PARAM,				"omronctl input parameter error."},
	{ID_OC_ERROR_SHAREDMEM,						UPS_EVENT_OC_ERROR_SHAREDMEM,			"omronctl detect shared mem error."},
	{ID_OC_WRITE_CMD_SHAREDMEM,					UPS_EVENT_OC_WRITE_CMD_SHAREDMEM,		"omronctl write cmd to shared mem."},

	{ID_UPS_READ_CMD_SHAREDMEM,					UPS_EVENT_READ_CMD_SHAREDMEM,			"service read cmd from shared mem."},
	{ID_UPS_ERROR_WRITE_PIPE,					UPS_EVENT_ERROR_WRITE_PIPE,				"service write pipe error."},
	{ID_UPS_WRITE_CMD_PIPE,						UPS_EVENT_WRITE_CMD_PIPE,				"service write cmd to pipe."},
	{ID_UPS_READ_CMD_PIPE,						UPS_EVENT_READ_CMD_PIPE,				"upsctl read cmd from pipe."},
	{ID_UPS_ERROR_SEND_UPSCMD,					UPS_EVENT_ERROR_SEND_UPSCMD,			"upsctl send ups command error."},
	{ID_UPS_SEND_UPSCMD,						UPS_EVENT_SEND_UPSCMD,					"upsctl send ups command ok."},
#endif
	/* Colin@2010-12-13 about Omronctl Error Event */ 
	{ID_OC_ERROR_COMM_UPS,						UPS_EVENT_OC_ERROR_COMM_UPS,			"[Omronctl error] SSD can't communicate with UPS."},
	{ID_OC_ERROR_CMD_EXEC,						UPS_EVENT_OC_ERROR_CMD_EXEC,			"[Omronctl error] the Command is executing."},
	{ID_OC_ERROR_SET_TIME,						UPS_EVENT_OC_ERROR_SET_TIME,			"[Omronctl error] Time setting is Wrong."},
	{ID_OC_WARRING_RESTART_DELAY,				UPS_EVENT_OC_WARRING_RESTART_DELAY,		"[Omronctl error] Can't do the schedule shutdown action."},
	{ID_OC_ERROR_OTHER,							UPS_EVENT_OC_ERROR_OTHER,				"[Omronctl error] Other errors."},


	{ID_DEBUG,									UPS_EVENT_DEBUG,						"INFO\n"},
};

int GetEventParamString(UINT uEvStrId, DWORD *uEventId, char *pszBuf)
{
	int	i;

	if (!pszBuf || !uEventId)
		return 0;

	for (i = 0; i < sizeof(Event_Param_Str)/sizeof(Event_Param_Str[0]); i++) {
		if (uEvStrId == Event_Param_Str[i].uEvStrId) {
			*uEventId = Event_Param_Str[i].uEventId;
			strcpy_s(pszBuf, MAX_LINELENGTH, Event_Param_Str[i].pszEventParamStr);
			return 1;
		}
	}

	return 0;
}

