// ServiceCtrl.h: interface for the CServiceCtrl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERVICECTRL_H__19ABFE73_359A_41E2_A6AA_6B32115A1F87__INCLUDED_)
#define AFX_SERVICECTRL_H__19ABFE73_359A_41E2_A6AA_6B32115A1F87__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <Windows.h>
#include "UpsCheck.h"

#define DESCRIPTION_SERVICE	("Simple Shutdown can communicate with OMRON UPS by COM and USB. It support External Command when it shutdowns system.")

class CServiceCtrl  
{
public:
	CServiceCtrl();
	virtual ~CServiceCtrl();

public:
	HINSTANCE	m_hInst;				//the instance handle of current process
	CUpsCheck	m_upsCheck;
protected:	

	HWND		m_hAgentCommWnd;		//the communication window's handle
	HANDLE		m_hStopServiceHandle;	//the event handle for stop service

	static		CServiceCtrl * m_pThis;	//used in the sttic function

	SERVICE_STATUS			m_ssStatus;
	SERVICE_STATUS_HANDLE	m_sshStatusHandle;
	
public:
	BOOL	InstallService();	//install server
	BOOL	AdjustAccessRights(char *lpszServiceName);

	void	Run();
	BOOL	StartService();		//start service, set the service main function
	void	StopService();		//stop service, set the event of m_hStopServiceHandle
	BOOL	RemoveService();	//uninstall service from system
	BOOL	ModifyServiceStatus(DWORD, DWORD, DWORD); //report the service status to manager
	BOOL	SetServiceDescription(LPCSTR lpDescription);
	static	void WINAPI ServiceMain(DWORD dwArgc, LPTSTR* lpszArgv);
	static	void WINAPI ServiceHandle(DWORD);
	
protected:
	BOOL	InitialService();
};

#endif // !defined(AFX_SERVICECTRL_H__19ABFE73_359A_41E2_A6AA_6B32115A1F87__INCLUDED_)
