#ifndef _UPS_H_
#define _UPS_H_

#include "..\Protocol.h"

#define	UPS_MAX						256
#define MAX_UPS_DATA_LENGTH			128

#define MAX_PORT_NUM				256
#define MAX_USB_NUM					128

#define MAX_PORT_FAIL_LOOP			4
#define MAX_COMMAND_LENGTH			20

#define UPS_STATUS_BATTLOW_Q1		0x1000000
#define UPS_STATUS_ACFAIL_Q1		0x10000000

#define MAX_PORT_NUM		256
#define MAX_PORTNAME_LEN	10	
#define MAX_COMPORT_NUM		256

#define PORT_MAX_NUMBER			 256

#define USBDLL_PATH			"USBDLL.dll"

typedef BOOL	((* POpenOneUSBDevice)(PUSBDNAME));
typedef int		((* PReadOneUSBDevice)(HANDLE, char * ));
typedef int		((* PWriteOneUSBDevice)(HANDLE, const char *));
typedef HANDLE	((* POpenUSBDeviceByName)(const char *));


class CUPS
{
public:
	CUPS(void);
public:
	~CUPS(void);

public:
	BOOL	SearchComUPS(UINT uComPort);
	BOOL	ConnectUPS(UINT uComPort, PortType porttype);
	BOOL	PollingUPS();
	void	ClosePort(PortType porttype);
	BOOL	UPSCmdQ1(char * szData);
	BOOL	UPSCmdSN(UINT uDown);
	BOOL	Initialize();
	void	CloseConnection(PortType pt);
	BOOL	OpenOneComDevice(int *comId ,BOOL bAuto);

private:

	int		OpenConnection(UINT uComPort, PortType prtttype);
	BOOL	SetupConnection();

	static	int		LayoutUsbList();
	DWORD	ListComPorts(DWORD *dwComID);
	int		GetCurrentPort(UINT uComPort);
	BOOL	ReadPort(UINT uLen, char *pszData);
	BOOL	WritePort(const char * pszData); //********sizeof(char*)
	BOOL	SendInstruction(const char * szOrder);
	BOOL	UPSReadOK();

private:	
	BOOL			m_bIsCanWritePort;
	static USBDNAME m_NewUsbDeviceItem;
	int				m_iNewUsbDeviceItem;
	
public:
	HMODULE			m_hUsbDll;
	HANDLE			m_hPortHandle;
	DWORD			m_dwUPSStatus;
	PortType		m_PortType;
	static TCHAR	m_szPort[MAX_PORT_NUM][MAX_PORTNAME_LEN];
	static DWORD	m_dwComPortCount;
	static USBDNAME m_UsbDeviceIDName[MAX_USB_NUM];
	UPSINFORMATION	m_upsInfo;

	USBDNAME		m_UsbDevice;
	PortType		m_ptDevType;

	int			m_nRestartTime;
	int			m_nOmronStatus;
};
#endif
